diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/config-store/model/display-functions.h ns-3.34/src/config-store/model/display-functions.h
--- ns-3.33/src/config-store/model/display-functions.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/config-store/model/display-functions.h	2021-07-14 10:31:06.000000000 -0700
@@ -27,6 +27,12 @@
 /**
  * This function includes the name of the attribute or the editable value
  * in the second column 
+ *
+ * \param col Pointer to the GtkTreeViewColumn
+ * \param renderer Pointer to the GtkCellRenderer
+ * \param model Pointer to the GtkTreeModel
+ * \param iter  Pointer to the GtkTreeIter
+ * \param user_data Pointer to the data to be displayed (or modified)
  */
 void
 cell_data_function_col_1 (GtkTreeViewColumn *col, GtkCellRenderer *renderer,
@@ -34,12 +40,22 @@
 /**
  * This function includes the name of the object, pointer, vector or vector item
  * in the first column
+ * \param col Pointer to the GtkTreeViewColumn
+ * \param renderer Pointer to the GtkCellRenderer
+ * \param model Pointer to the GtkTreeModel
+ * \param iter  Pointer to the GtkTreeIter
+ * \param user_data Pointer to the data to be displayed (or modified)
  */
 void
 cell_data_function_col_0 (GtkTreeViewColumn *col, GtkCellRenderer *renderer, GtkTreeModel *model,
                           GtkTreeIter *iter, gpointer user_data);
 /**
  * This is the callback called when the value of an attribute is changed
+ *
+ *  \param cell the changed cell
+ *  \param path_string the path
+ *  \param new_text the updated text in the cell
+ *  \param user_data user data
  */
 void
 cell_edited_callback (GtkCellRendererText *cell, gchar *path_string,
@@ -47,12 +63,22 @@
 /**
  * This function gets the column number 0 or 1 from the mouse
  * click
+ * \param col the column being clicked
+ * \returns the column index
  */
 int
 get_col_number_from_tree_view_column (GtkTreeViewColumn *col);
 /**
  * This function displays the tooltip for an object, pointer, vector
  * item or an attribute
+ *
+ * \param widget is the display object
+ * \param x is the x position
+ * \param y is the y position
+ * \param keyboard_tip
+ * \param tooltip is the tooltip information to be displayed
+ * \param user_data
+ * \return false if the tooltip is not displayed
  */
 gboolean
 cell_tooltip_callback (GtkWidget *widget, gint x, gint y, gboolean keyboard_tip, 
@@ -60,29 +86,51 @@
 /**
  * This is the main view opening the widget, getting tooltips and drawing the 
  * tree of attributes...
+ * \param model the GtkTreeStore model
+ * \returns a GtkWidget on success
  */
 GtkWidget *
 create_view (GtkTreeStore *model);
 /**
  * Exit the window when exit button is pressed
+ * \param button the pressed button
+ * \param user_data
  */
 void
 exit_clicked_callback (GtkButton *button, gpointer user_data);
 /**
  * Exit the application
+ * \param widget a pointer to the widget
+ * \param event the event responsible for the aplication exit
+ * \param user_data user data
+ * \returns true on clean exit
  */
 gboolean
 delete_event_callback (GtkWidget *widget, GdkEvent *event, gpointer user_data);
 /**
  * Delete the tree model contents
+ * \param model the GtkTreeModel
+ * \param path the GtkTreePath
+ * \param iter a GtkTreeIter
+ * \param data user data
+ * \return true if an error occurred.
  */
 gboolean
 clean_model_callback (GtkTreeModel *model, GtkTreePath *path,
                       GtkTreeIter *iter, gpointer data);
-/**************************     display functions used by default configurator **********************/
+
+
+//     display functions used by default configurator
+
 /**
  * This function writes data in the second column, this data is going to be editable
  * if it is a NODE_ATTRIBUTE
+ *
+ * \param col Pointer to the GtkTreeViewColumn
+ * \param renderer Pointer to the GtkCellRenderer
+ * \param model Pointer to the GtkTreeModel
+ * \param iter  Pointer to the GtkTreeIter
+ * \param user_data Pointer to the data to be displayed (or modified)
  */
 void
 cell_data_function_col_1_config_default (GtkTreeViewColumn *col, GtkCellRenderer *renderer, 
@@ -90,6 +138,11 @@
                                          gpointer user_data);
 /**
  * This function writes the attribute or typeid name in the column 0
+ * \param col Pointer to the GtkTreeViewColumn
+ * \param renderer Pointer to the GtkCellRenderer
+ * \param model Pointer to the GtkTreeModel
+ * \param iter  Pointer to the GtkTreeIter
+ * \param user_data Pointer to the data to be displayed (or modified)
  */
 void
 cell_data_function_col_0_config_default (GtkTreeViewColumn *col, GtkCellRenderer *renderer, GtkTreeModel *model, 
@@ -97,22 +150,34 @@
 /**
  * This is the action done when the user presses on the save button for the Default attributes.
  * It will save the config to a file.
+ *
+ * \param button (unused)
+ * \param user_data
  */
 void
 save_clicked_default (GtkButton *button, gpointer user_data);
 /**
  * If the user presses the button load, it will load the config file into memory for the Default attributes.
+ *
+ * \param button (unused)
+ * \param user_data
  */
 void
 load_clicked_default (GtkButton *button, gpointer user_data);
 /**
  * This is the action done when the user presses on the save button for the Attributes.
  * It will save the config to a file.
+ *
+ * \param button (unused)
+ * \param user_data
  */
 void
 save_clicked_attribute (GtkButton *button, gpointer user_data);
 /**
  * If the user presses the button load, it will load the config file into memory for the Attributes.
+ *
+ * \param button (unused)
+ * \param user_data
  */
 void
 load_clicked_attribute (GtkButton *button, gpointer user_data);
@@ -120,6 +185,11 @@
  *  This functions is called whenever there is a change in the value of an attribute
  *  If the input value is ok, it will be updated in the default value and in the
  *  GUI, otherwise, it won't be updated in both.
+ *
+ *  \param cell the changed cell
+ *  \param path_string the path
+ *  \param new_text the updated text in the cell
+ *  \param user_data user data
  */
 void
 cell_edited_callback_config_default (GtkCellRendererText *cell, gchar *path_string,
@@ -129,6 +199,14 @@
  * over a type ID or an attribute. It will give the type and the possible values of
  * an attribute value and the type of the object for an attribute object or a 
  * typeID object 
+ *
+ * \param widget is the display object
+ * \param x is the x position
+ * \param y is the y position
+ * \param keyboard_tip
+ * \param tooltip is the tooltip information to be displayed
+ * \param user_data
+ * \return false if the tooltip is not displayed
  */
 gboolean
 cell_tooltip_callback_config_default (GtkWidget *widget, gint x, gint y,
@@ -136,11 +214,18 @@
 /**
  * This is the main view opening the widget, getting tooltips and drawing the 
  * tree of attributes
+ * \param model the GtkTreeStore model
+ * \returns a GtkWidget on success
  */
 GtkWidget *
 create_view_config_default (GtkTreeStore *model);
 /**
  * Delete the tree model contents
+ * \param model the GtkTreeModel
+ * \param path the GtkTreePath
+ * \param iter a GtkTreeIter
+ * \param data user data
+ * \return true if an error occurred.
  */
 gboolean
 clean_model_callback_config_default (GtkTreeModel *model, GtkTreePath *path,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/config-store/model/model-typeid-creator.h ns-3.34/src/config-store/model/model-typeid-creator.h
--- ns-3.33/src/config-store/model/model-typeid-creator.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/config-store/model/model-typeid-creator.h	2021-07-14 10:31:06.000000000 -0700
@@ -66,15 +66,22 @@
   /**
    * \brief This method will iterate on typeIds having default attributes and create a model
    * for them, this model will be used by the view.
+   *
+   * \param treestore the GtkTreeStore.
    */
   void Build (GtkTreeStore *treestore);
 private:
   /**
    * \brief This method will add a ModelTypeid to the GtkTreeIterator
+   * \param tid TypeId
+   * \param name attribute name
+   * \param defaultValue default value
+   * \param index index of the attribute in the specified Typeid
    */
   virtual void VisitAttribute (TypeId tid, std::string name, std::string defaultValue, uint32_t index);
   /**
    * \brief Add a node for the new TypeId object
+   * \param name TypeId name
    */
   virtual void StartVisitTypeId (std::string name);
   /**
@@ -83,6 +90,7 @@
   virtual void EndVisitTypeId (void);
   /**
    * \brief Adds a treestore iterator to m_treestore model
+   * \param node the node to be added
    */
   void Add (ModelTypeid *node);
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/config-store/wscript ns-3.34/src/config-store/wscript
--- ns-3.33/src/config-store/wscript	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/config-store/wscript	2021-07-14 10:31:06.000000000 -0700
@@ -21,23 +21,21 @@
                                      conf.env['ENABLE_GTK'],
                                      "--disable-gtk option given")
     else:
-        have_gtk = conf.check_cfg(package='gtk+-3.0 >= 3.20',
+        have_gtk = conf.check_cfg(package='gtk+-3.0 >= 3.22',
                                   args=['--cflags', '--libs'], uselib_store='GTK',
                                   mandatory=False)
 
         conf.env['ENABLE_GTK'] = have_gtk
         conf.report_optional_feature("GtkConfigStore", "GtkConfigStore",
                                      conf.env['ENABLE_GTK'],
-                                     "library 'gtk+-3 >= 3.2' not found")
+                                     "library 'gtk+-3 >= 3.22' not found")
 
-        # Bug 2936 -Wparentheses issue for gcc >= 8
-        if conf.env['ENABLE_GTK']: 
+        # Bug 2936 and #340 -Wparentheses issue for gcc >= 8
+        # This have to be kept until we can bump the minimum GTK version to 3.24
+        if conf.env['ENABLE_GTK']:
             if conf.env['CXX_NAME'] in ['gcc']:
                 if tuple(map(int, conf.env['CC_VERSION'])) >= gcc_version_gtkplus_warning_issue:
                     conf.env.append_value('CXXFLAGS', '-Wno-parentheses')
-            # Bug 2978 gcc and clang warnings about deprecated declarations
-            if conf.env['CXX_NAME'] in ['clang', 'gcc']:
-                    conf.env.append_value ('CXXFLAGS', '-Wno-error=deprecated-declarations')
 
     have_libxml2 = conf.check_cfg(package='libxml-2.0 >= 2.7',
                                   args=['--cflags', '--libs'], uselib_store='LIBXML2',
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/bindings/modulegen__gcc_ILP32.py ns-3.34/src/core/bindings/modulegen__gcc_ILP32.py
--- ns-3.33/src/core/bindings/modulegen__gcc_ILP32.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/core/bindings/modulegen__gcc_ILP32.py	2021-07-14 10:31:06.000000000 -0700
@@ -161,6 +161,8 @@
     module.add_enum('State', ['RUNNING', 'EXPIRED', 'SUSPENDED'], outer_class=root_module['ns3::Timer'])
     ## timer-impl.h (module 'core'): ns3::TimerImpl [class]
     module.add_class('TimerImpl', allow_subclassing=True)
+    ## trickle-timer.h (module 'core'): ns3::TrickleTimer [class]
+    module.add_class('TrickleTimer')
     ## type-id.h (module 'core'): ns3::TypeId [class]
     module.add_class('TypeId')
     ## type-id.h (module 'core'): ns3::TypeId::AttributeFlag [enumeration]
@@ -604,6 +606,7 @@
     register_Ns3TimeWithUnit_methods(root_module, root_module['ns3::TimeWithUnit'])
     register_Ns3Timer_methods(root_module, root_module['ns3::Timer'])
     register_Ns3TimerImpl_methods(root_module, root_module['ns3::TimerImpl'])
+    register_Ns3TrickleTimer_methods(root_module, root_module['ns3::TrickleTimer'])
     register_Ns3TypeId_methods(root_module, root_module['ns3::TypeId'])
     register_Ns3TypeIdAttributeInformation_methods(root_module, root_module['ns3::TypeId::AttributeInformation'])
     register_Ns3TypeIdTraceSourceInformation_methods(root_module, root_module['ns3::TypeId::TraceSourceInformation'])
@@ -2092,6 +2095,73 @@
                    is_pure_virtual=True, is_virtual=True)
     return
 
+def register_Ns3TrickleTimer_methods(root_module, cls):
+    ## trickle-timer.h (module 'core'): ns3::TrickleTimer::TrickleTimer(ns3::TrickleTimer const & arg0) [constructor]
+    cls.add_constructor([param('ns3::TrickleTimer const &', 'arg0')])
+    ## trickle-timer.h (module 'core'): ns3::TrickleTimer::TrickleTimer() [constructor]
+    cls.add_constructor([])
+    ## trickle-timer.h (module 'core'): ns3::TrickleTimer::TrickleTimer(ns3::Time minInterval, uint8_t doublings, uint16_t redundancy) [constructor]
+    cls.add_constructor([param('ns3::Time', 'minInterval'), param('uint8_t', 'doublings'), param('uint16_t', 'redundancy')])
+    ## trickle-timer.h (module 'core'): int64_t ns3::TrickleTimer::AssignStreams(int64_t streamNum) [member function]
+    cls.add_method('AssignStreams', 
+                   'int64_t', 
+                   [param('int64_t', 'streamNum')])
+    ## trickle-timer.h (module 'core'): void ns3::TrickleTimer::ConsistentEvent() [member function]
+    cls.add_method('ConsistentEvent', 
+                   'void', 
+                   [])
+    ## trickle-timer.h (module 'core'): void ns3::TrickleTimer::Enable() [member function]
+    cls.add_method('Enable', 
+                   'void', 
+                   [])
+    ## trickle-timer.h (module 'core'): ns3::Time ns3::TrickleTimer::GetDelayLeft() const [member function]
+    cls.add_method('GetDelayLeft', 
+                   'ns3::Time', 
+                   [], 
+                   is_const=True)
+    ## trickle-timer.h (module 'core'): uint8_t ns3::TrickleTimer::GetDoublings() const [member function]
+    cls.add_method('GetDoublings', 
+                   'uint8_t', 
+                   [], 
+                   is_const=True)
+    ## trickle-timer.h (module 'core'): ns3::Time ns3::TrickleTimer::GetIntervalLeft() const [member function]
+    cls.add_method('GetIntervalLeft', 
+                   'ns3::Time', 
+                   [], 
+                   is_const=True)
+    ## trickle-timer.h (module 'core'): ns3::Time ns3::TrickleTimer::GetMaxInterval() const [member function]
+    cls.add_method('GetMaxInterval', 
+                   'ns3::Time', 
+                   [], 
+                   is_const=True)
+    ## trickle-timer.h (module 'core'): ns3::Time ns3::TrickleTimer::GetMinInterval() const [member function]
+    cls.add_method('GetMinInterval', 
+                   'ns3::Time', 
+                   [], 
+                   is_const=True)
+    ## trickle-timer.h (module 'core'): uint16_t ns3::TrickleTimer::GetRedundancy() const [member function]
+    cls.add_method('GetRedundancy', 
+                   'uint16_t', 
+                   [], 
+                   is_const=True)
+    ## trickle-timer.h (module 'core'): void ns3::TrickleTimer::InconsistentEvent() [member function]
+    cls.add_method('InconsistentEvent', 
+                   'void', 
+                   [])
+    ## trickle-timer.h (module 'core'): void ns3::TrickleTimer::Reset() [member function]
+    cls.add_method('Reset', 
+                   'void', 
+                   [])
+    ## trickle-timer.h (module 'core'): void ns3::TrickleTimer::SetParameters(ns3::Time minInterval, uint8_t doublings, uint16_t redundancy) [member function]
+    cls.add_method('SetParameters', 
+                   'void', 
+                   [param('ns3::Time', 'minInterval'), param('uint8_t', 'doublings'), param('uint16_t', 'redundancy')])
+    ## trickle-timer.h (module 'core'): void ns3::TrickleTimer::Stop() [member function]
+    cls.add_method('Stop', 
+                   'void', 
+                   [])
+    return
+
 def register_Ns3TypeId_methods(root_module, cls):
     cls.add_binary_comparison_operator('==')
     cls.add_binary_comparison_operator('!=')
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/bindings/modulegen__gcc_LP64.py ns-3.34/src/core/bindings/modulegen__gcc_LP64.py
--- ns-3.33/src/core/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/core/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:06.000000000 -0700
@@ -161,6 +161,8 @@
     module.add_enum('State', ['RUNNING', 'EXPIRED', 'SUSPENDED'], outer_class=root_module['ns3::Timer'])
     ## timer-impl.h (module 'core'): ns3::TimerImpl [class]
     module.add_class('TimerImpl', allow_subclassing=True)
+    ## trickle-timer.h (module 'core'): ns3::TrickleTimer [class]
+    module.add_class('TrickleTimer')
     ## type-id.h (module 'core'): ns3::TypeId [class]
     module.add_class('TypeId')
     ## type-id.h (module 'core'): ns3::TypeId::AttributeFlag [enumeration]
@@ -604,6 +606,7 @@
     register_Ns3TimeWithUnit_methods(root_module, root_module['ns3::TimeWithUnit'])
     register_Ns3Timer_methods(root_module, root_module['ns3::Timer'])
     register_Ns3TimerImpl_methods(root_module, root_module['ns3::TimerImpl'])
+    register_Ns3TrickleTimer_methods(root_module, root_module['ns3::TrickleTimer'])
     register_Ns3TypeId_methods(root_module, root_module['ns3::TypeId'])
     register_Ns3TypeIdAttributeInformation_methods(root_module, root_module['ns3::TypeId::AttributeInformation'])
     register_Ns3TypeIdTraceSourceInformation_methods(root_module, root_module['ns3::TypeId::TraceSourceInformation'])
@@ -2092,6 +2095,73 @@
                    is_pure_virtual=True, is_virtual=True)
     return
 
+def register_Ns3TrickleTimer_methods(root_module, cls):
+    ## trickle-timer.h (module 'core'): ns3::TrickleTimer::TrickleTimer(ns3::TrickleTimer const & arg0) [constructor]
+    cls.add_constructor([param('ns3::TrickleTimer const &', 'arg0')])
+    ## trickle-timer.h (module 'core'): ns3::TrickleTimer::TrickleTimer() [constructor]
+    cls.add_constructor([])
+    ## trickle-timer.h (module 'core'): ns3::TrickleTimer::TrickleTimer(ns3::Time minInterval, uint8_t doublings, uint16_t redundancy) [constructor]
+    cls.add_constructor([param('ns3::Time', 'minInterval'), param('uint8_t', 'doublings'), param('uint16_t', 'redundancy')])
+    ## trickle-timer.h (module 'core'): int64_t ns3::TrickleTimer::AssignStreams(int64_t streamNum) [member function]
+    cls.add_method('AssignStreams', 
+                   'int64_t', 
+                   [param('int64_t', 'streamNum')])
+    ## trickle-timer.h (module 'core'): void ns3::TrickleTimer::ConsistentEvent() [member function]
+    cls.add_method('ConsistentEvent', 
+                   'void', 
+                   [])
+    ## trickle-timer.h (module 'core'): void ns3::TrickleTimer::Enable() [member function]
+    cls.add_method('Enable', 
+                   'void', 
+                   [])
+    ## trickle-timer.h (module 'core'): ns3::Time ns3::TrickleTimer::GetDelayLeft() const [member function]
+    cls.add_method('GetDelayLeft', 
+                   'ns3::Time', 
+                   [], 
+                   is_const=True)
+    ## trickle-timer.h (module 'core'): uint8_t ns3::TrickleTimer::GetDoublings() const [member function]
+    cls.add_method('GetDoublings', 
+                   'uint8_t', 
+                   [], 
+                   is_const=True)
+    ## trickle-timer.h (module 'core'): ns3::Time ns3::TrickleTimer::GetIntervalLeft() const [member function]
+    cls.add_method('GetIntervalLeft', 
+                   'ns3::Time', 
+                   [], 
+                   is_const=True)
+    ## trickle-timer.h (module 'core'): ns3::Time ns3::TrickleTimer::GetMaxInterval() const [member function]
+    cls.add_method('GetMaxInterval', 
+                   'ns3::Time', 
+                   [], 
+                   is_const=True)
+    ## trickle-timer.h (module 'core'): ns3::Time ns3::TrickleTimer::GetMinInterval() const [member function]
+    cls.add_method('GetMinInterval', 
+                   'ns3::Time', 
+                   [], 
+                   is_const=True)
+    ## trickle-timer.h (module 'core'): uint16_t ns3::TrickleTimer::GetRedundancy() const [member function]
+    cls.add_method('GetRedundancy', 
+                   'uint16_t', 
+                   [], 
+                   is_const=True)
+    ## trickle-timer.h (module 'core'): void ns3::TrickleTimer::InconsistentEvent() [member function]
+    cls.add_method('InconsistentEvent', 
+                   'void', 
+                   [])
+    ## trickle-timer.h (module 'core'): void ns3::TrickleTimer::Reset() [member function]
+    cls.add_method('Reset', 
+                   'void', 
+                   [])
+    ## trickle-timer.h (module 'core'): void ns3::TrickleTimer::SetParameters(ns3::Time minInterval, uint8_t doublings, uint16_t redundancy) [member function]
+    cls.add_method('SetParameters', 
+                   'void', 
+                   [param('ns3::Time', 'minInterval'), param('uint8_t', 'doublings'), param('uint16_t', 'redundancy')])
+    ## trickle-timer.h (module 'core'): void ns3::TrickleTimer::Stop() [member function]
+    cls.add_method('Stop', 
+                   'void', 
+                   [])
+    return
+
 def register_Ns3TypeId_methods(root_module, cls):
     cls.add_binary_comparison_operator('==')
     cls.add_binary_comparison_operator('!=')
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/helper/csv-reader.cc ns-3.34/src/core/helper/csv-reader.cc
--- ns-3.33/src/core/helper/csv-reader.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/core/helper/csv-reader.cc	2021-07-14 10:31:06.000000000 -0700
@@ -28,6 +28,7 @@
 #include <iterator>
 #include <sstream>
 #include <vector>
+#include <limits>
 
 /**
  * \file
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/helper/csv-reader.h ns-3.34/src/core/helper/csv-reader.h
--- ns-3.33/src/core/helper/csv-reader.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/core/helper/csv-reader.h	2021-07-14 10:31:06.000000000 -0700
@@ -71,7 +71,7 @@
  *   while (csv.FetchNextRow ())
  *     {
  *       // Ignore blank lines
- *       if (csv.IsBlankLine ())
+ *       if (csv.IsBlankRow ())
  *         {
  *           continue;
  *         }
@@ -129,7 +129,7 @@
  *     # This row treated as a single empty column, returning an empty string.
  *     "" # So is this
  *
- * IsBlankLine() will return \c true in either of these cases.
+ * IsBlankRow() will return \c true in either of these cases.
  *
  * Quoted Columns
  * --------------
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/model/attribute-container-accessor-helper.h ns-3.34/src/core/model/attribute-container-accessor-helper.h
--- ns-3.33/src/core/model/attribute-container-accessor-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/core/model/attribute-container-accessor-helper.h	2021-07-14 10:31:06.000000000 -0700
@@ -32,14 +32,66 @@
 namespace ns3 {
 
 /**
+ * Compile time check if type T has const iterator.
+ */
+template<typename T>
+struct has_const_iterator
+{
+private:
+    typedef char                      yes;
+    typedef struct { char array[2]; } no;
+
+    template<typename C> static yes test(typename C::const_iterator*);
+    template<typename C> static no  test(...);
+public:
+    static const bool value = sizeof(test<T>(0)) == sizeof(yes);
+    typedef T type;
+};
+
+/**
+ * Compile time check if type T has begin() and end() methods.
+ */
+template <typename T>
+struct has_begin_end
+{
+    template<typename C> static char (&f(typename std::enable_if<
+      std::is_same<decltype(static_cast<typename C::const_iterator (C::*)() const>(&C::begin)),
+      typename C::const_iterator(C::*)() const>::value, void>::type*))[1];
+
+    template<typename C> static char (&f(...))[2];
+
+    template<typename C> static char (&g(typename std::enable_if<
+      std::is_same<decltype(static_cast<typename C::const_iterator (C::*)() const>(&C::end)),
+      typename C::const_iterator(C::*)() const>::value, void>::type*))[1];
+
+    template<typename C> static char (&g(...))[2];
+
+    static bool const beg_value = sizeof(f<T>(0)) == 1;
+    static bool const end_value = sizeof(g<T>(0)) == 1;
+};
+
+/**
+ * Compile time check if type T is a container.
+ *
+ * Container here means has an iterator and supports begin() and end()
+ * methods.
+ * 
+ * Can be used when defining specializations when a type T is an STL
+ * like container.
+ */
+template<typename T> 
+struct is_container : std::integral_constant<bool, has_const_iterator<T>::value && has_begin_end<T>::beg_value && has_begin_end<T>::end_value> 
+{ };
+
+/**
  * \ingroup attributeimpl
  *
  * DoMakeAccessorHelperOne specialization for member containers
  *
- * The template parameter list contains an extra parameter that disambiguates
- * the templated Ptr type from container types by taking advantage of the fact
- * that container types have multiple template arguments and Ptr has only one.
- * This disambiguation works but is not sufficiently robust as a long term solution.
+ * The template parameter list contains an extra parameter that is
+ * intended to disambiguate an attribute container from any other
+ * templated attribute, e.g Ptr or Callback.  Disambiguation is based
+ * on begin/end and iterator.
  *
  * \tparam V  \explicit The specific AttributeValue type to use to represent
  *            the Attribute.
@@ -50,7 +102,7 @@
  * \returns The AttributeAccessor.
  */
 template <typename V, typename T, template <typename...> class U, typename ...I,
-          typename = typename std::enable_if< (sizeof...(I) > 1), void>::type >
+          typename = typename std::enable_if< ( is_container< U<I...> >::value ), void>::type >
 inline
 Ptr<const AttributeAccessor>
 DoMakeAccessorHelperOne (U<I...> T::*memberContainer)
@@ -98,4 +150,4 @@
 
 } // namespace ns3
 
-#endif  // ATTRIBUTE_CONTAINER_ACCESSOR_HELPER_H
\ No newline at end of file
+#endif  // ATTRIBUTE_CONTAINER_ACCESSOR_HELPER_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/model/config.cc ns-3.34/src/core/model/config.cc
--- ns-3.33/src/core/model/config.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/core/model/config.cc	2021-07-14 10:31:06.000000000 -0700
@@ -870,6 +870,8 @@
     {
       return false;
     }
+  struct TypeId::AttributeInformation info;
+  tid.LookupAttributeByName(paramName, &info);
   for (uint32_t j = 0; j < tid.GetAttributeN (); j++)
     {
       struct TypeId::AttributeInformation tmp = tid.GetAttribute (j);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/model/deprecated.h ns-3.34/src/core/model/deprecated.h
--- ns-3.33/src/core/model/deprecated.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/core/model/deprecated.h	2021-07-14 10:31:06.000000000 -0700
@@ -64,6 +64,15 @@
 
 /**
  * \ingroup core
+ * \def NS_DEPRECATED_3_34
+ * Tag for things deprecated in version ns-3.34.
+ */
+#ifdef NS_DEPRECATED
+#define NS_DEPRECATED_3_34 NS_DEPRECATED
+#endif
+
+/**
+ * \ingroup core
  * \def NS_DEPRECATED_3_32
  * Tag for things deprecated in version ns-3.32.
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/model/length.h ns-3.34/src/core/model/length.h
--- ns-3.33/src/core/model/length.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/core/model/length.h	2021-07-14 10:31:06.000000000 -0700
@@ -24,7 +24,7 @@
 #include "attribute.h"
 #include "attribute-helper.h"
 
-#ifdef HAVE_BOOST_UNITS
+#ifdef HAVE_BOOST
 #include <boost/units/quantity.hpp>
 #include <boost/units/systems/si.hpp>
 #endif
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/model/node-printer.cc ns-3.34/src/core/model/node-printer.cc
--- ns-3.33/src/core/model/node-printer.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/core/model/node-printer.cc	2021-07-14 10:31:06.000000000 -0700
@@ -34,12 +34,6 @@
 
 NS_LOG_COMPONENT_DEFINE ("NodePrinter");
 
-/**
- * \ingroup logging
- * Default node id printer implementation.
- *
- * \param [in,out] os The output stream to print the node id on.
- */
 void
 DefaultNodePrinter (std::ostream &os)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/model/node-printer.h ns-3.34/src/core/model/node-printer.h
--- ns-3.33/src/core/model/node-printer.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/core/model/node-printer.h	2021-07-14 10:31:06.000000000 -0700
@@ -40,9 +40,10 @@
 typedef void (*NodePrinter)(std::ostream &os);
 
 /**
- * Default Node printer.
+ * \ingroup logging
+ * Default node id printer implementation.
  *
- * \param [in,out] os The output stream to print on.
+ * \param [in,out] os The output stream to print the node id on.
  */
 void DefaultNodePrinter (std::ostream &os);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/core/model/object.h ns-3.34/src/core/model/object.h
--- ns-3.33/src/core/model/object.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/core/model/object.h	2021-07-14 10:31:06.000000000 -0700
@@ -485,6 +485,12 @@
   return 0;
 }
 
+/**
+ * Specialization of \link Object::GetObject () \endlink for
+ * objects of type ns3::Object.
+ *
+ * \returns A Ptr to the calling object.
+ */
 template
 <>
 inline Ptr<Object>
@@ -505,6 +511,13 @@
   return 0;
 }
 
+/**
+ * Specialization of \link Object::GetObject (TypeId tid) \endlink for
+ * objects of type ns3::Object.
+ *
+ * \param [in] tid The TypeId of the requested Object.
+ * \returns A Ptr to the calling object.
+ */
 template
 <>
 inline Ptr<Object>
